--Stalker Anomalies 2.0 by 2Gen
--[[ 
atypes
1 - springboar 
2 - vortex 
3 - burner 
4 - electro 
5 - fruit punch 
]]

ANOMALIES = {
	[1] = {
		x = 197,--  
		y = 181,
		atype = 1,
		
		state = 0,
		players={},
		factor = 0,
	},
	[2] = {
		x = 522,
		y = 531,
		atype = 2,
		
		state = 0,
		players={},
		factor = 0,
	},	
	[3] = {
		x = 620,
		y = 180,
		atype = 3,
		
		state = 0,
		players={},
		factor = 0,
	},
	[4] = {
		x = 130,
		y = 680,
		atype = 4,
		
		state = 0,
		players={},
		factor = 0,
	},
}

function anom_maps()--       
	if map("name") == "! lua_test_anom g2" then
		ANOMALIES[1].x = 190
		ANOMALIES[1].y = 190
		ANOMALIES[1].atype = 1
		
		ANOMALIES[2].x = 510
		ANOMALIES[2].y = 120
		ANOMALIES[2].atype = 3
		
		ANOMALIES[3].x = 615
		ANOMALIES[3].y = 440
		ANOMALIES[3].atype = 1
		
		ANOMALIES[4].x = 160
		ANOMALIES[4].y = 570
		ANOMALIES[4].atype = 3
		
	elseif map("name") == "! lua_test_anom g3" then
		ANOMALIES[1].x = 150
		ANOMALIES[1].y = 150
		ANOMALIES[1].atype = 4
		
		ANOMALIES[2].x = 300
		ANOMALIES[2].y = 150
		ANOMALIES[2].atype = 4
		
		ANOMALIES[3].x = 150
		ANOMALIES[3].y = 300
		ANOMALIES[3].atype = 4
		
		ANOMALIES[4].x = 450
		ANOMALIES[4].y = 150
		ANOMALIES[4].atype = 4
		
		ANOMALIES[#ANOMALIES+1]= {x = 150,y = 450,atype = 4,state = 0,players={},factor = 0,}--   
		
		ANOMALIES[#ANOMALIES+1]= {x = 300,y = 300,atype = 4,state = 0,players={},factor = 0,}
		
	elseif map("name") == "! lua_test_anom g4" then		
		ANOMALIES[1].x = math.random(100,300)--    
		ANOMALIES[1].y = math.random(100,300)
		ANOMALIES[1].atype = 5
		
		ANOMALIES[2].x = math.random(400,600)
		ANOMALIES[2].y = math.random(400,600)
		ANOMALIES[2].atype = 5
		
		table.remove(ANOMALIES, 4)--  
		table.remove(ANOMALIES, 3)
		
	elseif map("name") == "! lua_test_anom g5" then
		ANOMALIES[4].x = 200
		ANOMALIES[4].y = 456
		ANOMALIES[4].atype = 4
		
		ANOMALIES[#ANOMALIES+1]= {x = 401,y = 315,atype = 5,state = 0,players={},factor = 0,}
		
	elseif map("name") == "! 2gen_anomalies_script_preview" then
		ANOMALIES[1].x = 155
		ANOMALIES[1].y = 155
		ANOMALIES[1].atype = 1
		
		ANOMALIES[3].x = 829
		ANOMALIES[3].y = 161
		ANOMALIES[3].atype = 3
		
		ANOMALIES[#ANOMALIES+1]= {x = 540,y = 183,atype = 5,state = 0,players={},factor = 0,}
		
		ANOMALIES[#ANOMALIES+1]= {x = 750,y = 900,atype = 4,state = 0,players={},factor = 0,}
		
		ANOMALIES[#ANOMALIES+1]= {x = 877,y = 797,atype = 4,state = 0,players={},factor = 0,}
		
	end
	--print(#ANOMALIES)
end
anom_maps()

timer(500,"parse","lua anom_start()")--   1 

function anom_start()
for i, v in ipairs(ANOMALIES) do
--print("spawn anomaly")

if ANOMALIES[i].atype == 1 then
a_img[i] = image("gfx/! stalker/smoke_ring.png", 0, 1, 3)
imagepos(a_img[i], ANOMALIES[i].x, ANOMALIES[i].y, 0)
imagealpha(a_img[i],0)
imagescale(a_img[i],0.2,0.2)
tween_rotateconstantly(a_img[i], -5)
imagecolor(a_img[i],100,100,100)

elseif ANOMALIES[i].atype == 2 then
a_img[i] = image("gfx/! stalker/anomaly_vortex.png", 0, 1, 3)
imagepos(a_img[i], ANOMALIES[i].x, ANOMALIES[i].y, 0)
imagealpha(a_img[i],0)
imagescale(a_img[i],1,1)
tween_rotateconstantly(a_img[i], 10)

elseif ANOMALIES[i].atype == 3 then
a_img[i] = image("gfx/! stalker/Fire-a.png", 0, 1, 3)
a_img2[i] = image("gfx/! stalker/Fire-b.png", 0, 1, 3)
a_img3[i] = image("gfx/! stalker/Fire-c.png", 0, 1, 3)
imagepos(a_img[i], ANOMALIES[i].x, ANOMALIES[i].y, 0)
imagepos(a_img2[i], ANOMALIES[i].x, ANOMALIES[i].y, 0)
imagepos(a_img3[i], ANOMALIES[i].x, ANOMALIES[i].y, 0)
imagealpha(a_img[i],0)
imagealpha(a_img2[i],0)
imagealpha(a_img3[i],0)
imagescale(a_img[i],0.1,0.1)
imagescale(a_img2[i],0.1,0.1)
imagescale(a_img3[i],0.1,0.1)
tween_rotateconstantly(a_img[i], 3)
tween_rotateconstantly(a_img2[i], 2)
tween_rotateconstantly(a_img3[i], -3)

elseif ANOMALIES[i].atype == 4 then
a_img[i] = image("gfx/! stalker/anomaly_electro.png", 0, 1, 3)
a_img2[i] = image("gfx/! stalker/anomaly_electro.png", 0, 1, 3)
imagepos(a_img[i], ANOMALIES[i].x, ANOMALIES[i].y, 0)
imagepos(a_img2[i], ANOMALIES[i].x, ANOMALIES[i].y, 0)
imagealpha(a_img[i],0)
imagealpha(a_img2[i],0)
imagescale(a_img[i],0.01,0.01)
imagescale(a_img2[i],0.01,0.01)
tween_rotateconstantly(a_img[i], 5)
tween_rotateconstantly(a_img2[i], -4)

elseif ANOMALIES[i].atype == 5 then
a_img[i] = image("gfx/! stalker/anomaly_kisel.png", 0, 1, 0)
imagepos(a_img[i], ANOMALIES[i].x, ANOMALIES[i].y, math.random(0,360))
imagealpha(a_img[i],0.8)
imagescale(a_img[i],0.8,0.8)
end
end
--print(#ANOMALIES)
end

addhook("startround","anom_reset")--     
function anom_reset(mode)
print("reset anomalies")
for i, v in ipairs(ANOMALIES) do
if ANOMALIES[i].atype == 1 then
freeimage(a_img[i])
elseif ANOMALIES[i].atype == 2 then
freeimage(a_img[i])
elseif ANOMALIES[i].atype == 3 then
freeimage(a_img[i])
freeimage(a_img2[i])
freeimage(a_img3[i])
elseif ANOMALIES[i].atype == 4 then
freeimage(a_img[i])
freeimage(a_img2[i])
elseif ANOMALIES[i].atype == 5 then
freeimage(a_img[i])
end
end
anom_start()
end

function dist_array()--dist[i]   dist[i][i]    ANOMALIES
dist={}
for i=1,32 do
dist[i]={}
dist[i][i]=0
end
return dist
end

function initArray(m) local array = {} for i = 1, m do array[i]=0 end return array end
x=initArray(32,0)
y=initArray(32,0)
sideA=initArray(32,0)
sideB=initArray(32,0)
dist=dist_array()

detector_state=initArray(32,0)
detector_i1=initArray(32,0)
detector_i2=initArray(32,0)
detector_i3=initArray(32,0)
detector_i4=initArray(32,0)

a_img=initArray(32,0)
a_img2=initArray(32,0)
a_img3=initArray(32,0)

new_x=initArray(32,0)
new_y=initArray(32,0)
inAnomaly=initArray(32,0)
beep = initArray(32,0)
anom_timer = initArray(32,0)
sound_timer = initArray(32,0)

function math.dist(id)--    . :D
	
	for i, v in ipairs(ANOMALIES) do
		local px, py = player(id, "x"), player(id, "y")
		x[i], y[i] = ANOMALIES[i].x, ANOMALIES[i].y
		sideA[i] = math.max(px,x[i])-math.min(px,x[i])
		sideB[i] = math.max(py,y[i])-math.min(py,y[i])
		dist[id][i] = math.sqrt(sideA[i]^2+sideB[i]^2)--    
		--print("player id "..id.." in "..dist[id][i].." pixels from anomaly "..i)
	end

end

function math.dist_vortex(id, i)--    =(

	local px, py = player(id, "x"), player(id, "y")
		x[i], y[i] = ANOMALIES[i].x, ANOMALIES[i].y
		if px < x[i] then
			new_x[id] = px+math.random(5,9)
		else
			new_x[id] = px-math.random(5,9)
		end
	
		if py < y[i] then
			new_y[id] = py+math.random(5,9)
		else
			new_y[id] = py-math.random(5,9)
		end
	parse("setpos "..id.." "..new_x[id] .." "..new_y[id])

end

function detector_beep(id,dist)
beep[id] = beep[id]+1

if dist < 100 then
	if beep[id] >= 2 then	
		beep[id] = 0
		--parse("effect \"flare\" "..player(id, "x").." "..player(id, "y").." 3 5 160 40 40")
		parse("sv_sound2 " .. id .. " ! stalker/detector_2.ogg")
	end
elseif dist < 120 then
	if beep[id] >= 2 then
		beep[id] = 0
		parse("sv_sound2 " .. id .. " ! stalker/detector_2.ogg")
	end
elseif dist < 160 then
	if beep[id] >= 3 then
		beep[id] = 0
		parse("sv_sound2 " .. id .. " ! stalker/detector_2.ogg")
	end
elseif dist < 210 then
	if beep[id] >= 8 then
		beep[id] = 0
		parse("sv_sound2 " .. id .. " ! stalker/detector_2.ogg")
	end
end
end

addhook("ms100","anomaly_find")
function anomaly_find()--        
for _, id in pairs(player(0, "tableliving")) do	
		
	math.dist(id)
	detector_i1[id] = 0
	detector_i2[id] = 0
	detector_i3[id] = 0
	detector_i4[id] = 0
	detector_state[id]=0
	
			for i = 1,#ANOMALIES do
			if dist[id][i] < 100 then
				parse("effect \"flare\" "..player(id, "x").." "..player(id, "y").." 1 3 160 40 40")
				inAnomaly[id]=i
				ANOMALIES[i].players[id]=1
				anomaly_speedmod(id,i)
				detector_state[id]=1
				detector_i1[id] = i
			elseif dist[id][i] < 120 then
				parse("speedmod "..id.." 0")
				
				ANOMALIES[i].players[id]=0
				detector_state[id]=1
				detector_i2[id] = i
					if inAnomaly[id] > 0 then--     
						if dist[id][inAnomaly[id]] < 100 then
						else
							inAnomaly[id]=0
						end	
					end
			elseif dist[id][i] < 160 then
				parse("speedmod "..id.." 0")
					if inAnomaly[id] > 0 then
						if dist[id][inAnomaly[id]] < 100 then
						else
							inAnomaly[id]=0
						end	
					end
				ANOMALIES[i].players[id]=0
				detector_state[id]=1
				detector_i3[id] = i
			elseif dist[id][i] < 210 then
				parse("speedmod "..id.." 0")
					if inAnomaly[id] > 0 then
						if dist[id][inAnomaly[id]] < 100 then
						else
							inAnomaly[id]=0
						end	
					end
				ANOMALIES[i].players[id]=0
				detector_state[id]=1
				detector_i4[id] = i
			else
				ANOMALIES[i].players[id]=0
			end
			end
				if detector_state[id]==1 then --    
					if detector_i1[id] > 0 then
						detector_beep(id,dist[id][detector_i1[id]])
					elseif detector_i2[id] > 0 then
						detector_beep(id,dist[id][detector_i2[id]])
					elseif detector_i3[id] > 0 then
						detector_beep(id,dist[id][detector_i3[id]])
					elseif detector_i4[id] > 0 then
						detector_beep(id,dist[id][detector_i4[id]])
					end
				end
	end
anom_wait_effects()
end

addhook("second","anom_damage_second")
function anom_damage_second()--     
	for _, id in pairs(player(0, "tableliving")) do
		if inAnomaly[id] > 0 then
		--print("DAMAGE")
			if ANOMALIES[inAnomaly[id]].atype == 1 then
				parse("sethealth "..id.." "..(player(id,"health") - 10))
			elseif ANOMALIES[inAnomaly[id]].atype == 2 then
				if sound_timer[inAnomaly[id]] == 6 then
					parse("sethealth "..id.." "..(player(id,"health") - 50))
				end
			elseif ANOMALIES[inAnomaly[id]].atype == 3 then
				parse("sethealth "..id.." "..(player(id,"health") - 15))
			elseif ANOMALIES[inAnomaly[id]].atype == 4 then
				if sound_timer[inAnomaly[id]] == 1 then
					parse("sethealth "..id.." "..(player(id,"health") - 20))
				end
			elseif ANOMALIES[inAnomaly[id]].atype == 5 then
				parse("sethealth "..id.." "..(player(id,"health") - 5))
			end
		end
	end
end

addhook("die","die_clear_states")
function die_clear_states(id)
for i = 1,#ANOMALIES do
ANOMALIES[i].players[id] = 0
end
inAnomaly[id]=0
end

addhook("leave","leave_clear_states")
function leave_clear_states(id)
for i = 1,#ANOMALIES do
ANOMALIES[i].players[id] = 0
end
end

addhook("second","anom_activate")
function anom_activate()--    ,   
	for i, v in ipairs(ANOMALIES) do
		ANOMALIES[i].factor = 0
		
			if ANOMALIES[i].state == 1 then--  
				for pid = 1,#ANOMALIES[i].players do
				if ANOMALIES[i].players[pid] == 1 then
					ANOMALIES[i].factor = ANOMALIES[i].factor+1--      
					--print("at least 1 players in anomaly "..i)
				end
				end
				
				if ANOMALIES[i].factor == 0 then
					anom_deactivate(i)
					--print("deactivating anomaly "..i)
				end
			else
				for pid = 1,#ANOMALIES[i].players do--     1 
				if ANOMALIES[i].players[pid] == 1 then
					ANOMALIES[i].state = 1
					--print("activating anomaly "..i)
				end
				end
			end
		--print("anomaly factor is "..ANOMALIES[i].factor)
		--print("number of players is "..#player(0,"table"))
		
	end
end

function anom_deactivate(i)
	if ANOMALIES[i].state == 1 then
		ANOMALIES[i].state = 0
	end
end

addhook("second","anomaly_types")
function anomaly_types()
for i, v in ipairs(ANOMALIES) do
if ANOMALIES[i].state == 1 then
	if ANOMALIES[i].atype == 1 then
	atype_springboar(i)
	elseif ANOMALIES[i].atype == 2 then
	atype_vortex(i)
	elseif ANOMALIES[i].atype == 3 then
	atype_burner(i)
	elseif ANOMALIES[i].atype == 4 then
	atype_electro(i)
	elseif ANOMALIES[i].atype == 5 then
	atype_kisel(i)
	end
else
if ANOMALIES[i].atype == 2 then
	--imagealpha(a_img[i],0)
	tween_alpha(a_img[i],1500,0)--     
elseif ANOMALIES[i].atype == 3 then
	tween_alpha(a_img[i],1500,0)
	tween_alpha(a_img2[i],1500,0)
	tween_alpha(a_img3[i],1500,0)
elseif ANOMALIES[i].atype == 4 then
	tween_alpha(a_img[i],1000,0)
	tween_alpha(a_img2[i],1000,0)
end
end

end
end

function anomaly_speedmod(id,i)
if ANOMALIES[i].atype == 1 then
parse("speedmod "..id.." -15")

elseif ANOMALIES[i].atype == 2 then
math.dist_vortex(id,i)
parse("speedmod "..id.." -20")

elseif ANOMALIES[i].atype == 3 then
parse("speedmod "..id.." -15")

elseif ANOMALIES[i].atype == 4 then
parse("speedmod "..id.." -15")

elseif ANOMALIES[i].atype == 5 then
parse("speedmod "..id.." -23")

end
end

function atype_springboar(i)
imagealpha(a_img[i],0.8)
imagescale(a_img[i],0.1,0.1)
parse('sv_soundpos "! stalker/anomaly_gravi_1.ogg" '..ANOMALIES[i].x..' '..ANOMALIES[i].y)
parse("effect \"colorsmoke\" "..ANOMALIES[i].x.." "..ANOMALIES[i].y.." 30 135 50 40 40")
tween_scale(a_img[i],700,1.8,1.8)
tween_alpha(a_img[i],650,0)
end


function atype_vortex(i)
sound_timer[i] = sound_timer[i]+1--     
--imagealpha(a_img[i],0.5)
tween_alpha(a_img[i],1500,0.5)
parse("effect \"colorsmoke\" "..ANOMALIES[i].x.." "..ANOMALIES[i].y.." 30 95 227 236 235")
if sound_timer[i] == 1 then
--imagescale(a_img[i],1.3,1.3)
--tween_scale(a_img[i],7000,0.5,0.5)
parse('sv_soundpos "! stalker/anomaly_vortex_1.ogg" '..ANOMALIES[i].x..' '..ANOMALIES[i].y)
elseif sound_timer[i] == 7 then
sound_timer[i] = 0
end
end

function atype_burner(i)
sound_timer[i] = sound_timer[i]+1
tween_alpha(a_img[i],500,0.3)
tween_alpha(a_img2[i],600,0.3)
tween_alpha(a_img3[i],700,0.3)

tween_scale(a_img[i],700,0.9,0.9)
tween_scale(a_img2[i],600,0.6,0.6)
tween_scale(a_img3[i],700,1,1)

parse("effect \"fire\" "..ANOMALIES[i].x.." "..ANOMALIES[i].y.." 30 135 0 0 0")
if sound_timer[i] == 1 then
--imagescale(a_img[i],1.3,1.3)
--tween_scale(a_img[i],7000,0.5,0.5)
parse('sv_soundpos "! stalker/anomaly_burner_1.ogg" '..ANOMALIES[i].x..' '..ANOMALIES[i].y)
elseif sound_timer[i] == 9 then
sound_timer[i] = 0
end
end

function atype_electro(i)
sound_timer[i] = sound_timer[i]+1
if sound_timer[i] == 1 then
tween_alpha(a_img[i],700,0.5)
tween_alpha(a_img2[i],700,0.5)

tween_scale(a_img[i],800,0.7,0.7)
tween_scale(a_img2[i],800,0.5,0.5)

parse("effect \"flare\" "..ANOMALIES[i].x.." "..ANOMALIES[i].y.." 40 115 50 70 245")
elseif sound_timer[i] == 2 then
tween_alpha(a_img[i],300,0)
tween_alpha(a_img2[i],300,0)

tween_scale(a_img[i],300,0.02,0.02)
tween_scale(a_img2[i],300,0.01,0.01)
--imagescale(a_img[i],1.3,1.3)
--tween_scale(a_img[i],7000,0.5,0.5)
parse('sv_soundpos "! stalker/anomaly_electro_1.ogg" '..ANOMALIES[i].x..' '..ANOMALIES[i].y)
--elseif sound_timer[i] == 2 then
sound_timer[i] = 0
end
end

function atype_kisel(i)
parse('sv_soundpos "! stalker/anomaly_kisel_1.ogg" '..ANOMALIES[i].x..' '..ANOMALIES[i].y)
parse("effect \"colorsmoke\" "..ANOMALIES[i].x.." "..ANOMALIES[i].y.." 30 135 75 180 85")
parse("effect \"flare\" "..ANOMALIES[i].x.." "..ANOMALIES[i].y.." 40 115 55 190 70")
end

--addhook("second","anom_wait_effects")
function anom_wait_effects()
--for i, v in ipairs(ANOMALIES) do
for i=1,#ANOMALIES do

if ANOMALIES[i].atype == 1 then
	parse("effect \"colorsmoke\" "..ANOMALIES[i].x+math.random(-50,50).." "..ANOMALIES[i].y+math.random(-50,50).." 1 1 50 40 40")
elseif ANOMALIES[i].atype == 2 then
	parse("effect \"colorsmoke\" "..ANOMALIES[i].x+math.random(-50,50).." "..ANOMALIES[i].y+math.random(-50,50).." 1 1 227 236 235")
elseif ANOMALIES[i].atype == 3 then
	parse("effect \"fire\" "..ANOMALIES[i].x+math.random(-50,50).." "..ANOMALIES[i].y+math.random(-50,50).." 1 1 0 0 0")
elseif ANOMALIES[i].atype == 4 then
	parse("effect \"flare\" "..ANOMALIES[i].x+math.random(-50,50).." "..ANOMALIES[i].y+math.random(-50,50).." 1 1 50 50 250")
elseif ANOMALIES[i].atype == 5 then
	parse("effect \"colorsmoke\" "..ANOMALIES[i].x+math.random(-50,50).." "..ANOMALIES[i].y+math.random(-50,50).." 1 1 75 180 85")
end

end
end


--
--
--
--
--
--
--
--